<link rel="import" href="../polymer/polymer-element.html">

<link rel="import" href="../neon-animation/web-animations.html">
<link rel="import" href="../paper-listbox/paper-listbox.html">
<link rel="import" href="../paper-item/paper-item.html">
<link rel="import" href="../paper-menu-button/paper-menu-button.html">
<link rel="import" href="../paper-icon-button/paper-icon-button.html">
<link rel="import" href="../iron-icons/iron-icons.html">
<link rel="import" href="../iron-icon/iron-icon.html">

<dom-module id="dez-analyses-dropdown">
  <template>
    <style>
      @media (max-width: 1024px) {
        .hidden-xs {
          display: none;
        }

        @media (max-width: 700px) {
          .hidden-xxs {
            display: none;
          }
        }
      }
    </style>
    <span class="analysis-name hidden-xxs">[[_analysisName]]</span>
    <paper-menu-button  noink no-animations>
      <paper-icon-button icon="cloud-download" title="load analysis (cloud)" slot="dropdown-trigger"></paper-icon-button>
      <paper-listbox id="analysesMenu" slot="dropdown-content" on-iron-select="_selectAnalysis" selected="{{_analysisIndex}}">
        <template is="dom-repeat" items="{{analyses}}" as="analysis">
          <paper-item>[[analysis]]</paper-item>
        </template>
      </paper-listbox>
    </paper-menu-button>

  </template>

  <script>
    class DezAnalysesDropdown extends Polymer.Element {
      static get is() { return 'dez-analyses-dropdown'; }
      static get properties() {
        return {
          analyses: {
              type: Array,
              observer: '_analysesChanged'
          }
        };
      }

      constructor (){
        super()
        this._listInit = false
      }

      set name (name) {
        this._analysisIndex = this.analyses.indexOf(name);
        this._analysisName = name;
      }

      confirmSelected () {
          this._analysisIndex = this._itemToConfirm;
          this._analysisName = this.analyses[this._itemToConfirm];
      }

      _analysesChanged () { // change piece
          let name = this.analyses[0]
          this._listInit = true
          this._analysisIndex = this.analyses.indexOf(name);
          this._analysisName = name;
          this._listInit = false
      }

      _selectAnalysis (e, detail) {
          if (this._listInit) { // on listbox init
            this._itemToConfirm = this._analysisIndex
          } else {
            let name = detail.item.innerText
            this._itemToConfirm = this.analyses.indexOf(name);
            this.dispatchEvent(new CustomEvent(
              'new-analysis-selected',
              {detail: {name: name}}
            ));
          }
      }

    }

    window.customElements.define(DezAnalysesDropdown.is, DezAnalysesDropdown);
  </script>
</dom-module>
